AtomicReferenceDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser.std

## Class AtomicReferenceDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<T>
  - - org.codehaus.jackson.map.deser.std.StdDeserializer<T>
    - - org.codehaus.jackson.map.deser.std.StdScalarDeserializer<AtomicReference<?>>
      - - org.codehaus.jackson.map.deser.std.AtomicReferenceDeserializer

- All Implemented Interfaces:
    ResolvableDeserializer

      public class AtomicReferenceDeserializer
      extends StdScalarDeserializer<AtomicReference<?>>
      implements ResolvableDeserializer

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `StdDeserializer.BigDecimalDeserializer, StdDeserializer.BigIntegerDeserializer, StdDeserializer.BooleanDeserializer, StdDeserializer.ByteDeserializer, StdDeserializer.CharacterDeserializer, StdDeserializer.DoubleDeserializer, StdDeserializer.FloatDeserializer, StdDeserializer.IntegerDeserializer, StdDeserializer.LongDeserializer, StdDeserializer.NumberDeserializer, StdDeserializer.PrimitiveOrWrapperDeserializer<T>, StdDeserializer.ShortDeserializer, StdDeserializer.SqlDateDeserializer, StdDeserializer.StackTraceElementDeserializer`

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected BeanProperty` | `_property`
    `protected JavaType` | `_referencedType` Type of value that we reference
    `protected JsonDeserializer<?>` | `_valueDeserializer`

    - ### Fields inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AtomicReferenceDeserializer(JavaType referencedType, BeanProperty property)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AtomicReference<?>` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `void` | `resolve(DeserializationConfig config, DeserializerProvider provider)` Method called after `DeserializerProvider` has registered the deserializer, but before it has returned it to the caller.

    - ### Methods inherited from class org.codehaus.jackson.map.deser.std.StdScalarDeserializer

      `deserializeWithType`

    - ### Methods inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultSerializer, parseDouble, reportUnknownProperty`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonDeserializer

      `deserialize, getEmptyValue, getNullValue, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _referencedType

          protected final JavaType _referencedType

      Type of value that we reference

    - #### _property

          protected final BeanProperty _property

    - #### _valueDeserializer

          protected JsonDeserializer<?> _valueDeserializer

  - ### Constructor Detail

    - #### AtomicReferenceDeserializer

          public AtomicReferenceDeserializer(JavaType referencedType,
                                     BeanProperty property)

      Parameters:
        `referencedType` - Parameterization of this reference

  - ### Method Detail

    - #### deserialize

          public AtomicReference<?> deserialize(JsonParser jp,
                                       DeserializationContext ctxt)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<AtomicReference<?>>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### resolve

          public void resolve(DeserializationConfig config,
                     DeserializerProvider provider)
                       throws JsonMappingException

      Description copied from interface: `ResolvableDeserializer`
      Method called after `DeserializerProvider` has registered the deserializer, but before it has returned it to the caller. Called object can then resolve its dependencies to other types, including self-references (direct or indirect).
      Specified by:
        `resolve` in interface `ResolvableDeserializer`
        `provider` - Provider that has constructed deserializer this method is called on.
      Throws:
        `JsonMappingException`